/*
Rotary encoder test 
 */
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "ks0108.h"
#include "rotary.h"
#include "SC.h"
#ifndef F_CPU
//define cpu clock speed if not defined
#define F_CPU 16000000
#endif
//Strings in flash
const char LEFT[] PROGMEM="LEFT TURN";
const char RIGHT[] PROGMEM="RIGHT TURN";
const char BUTTON[] PROGMEM="BUTTON CLICK";
const char DEMO[] PROGMEM="Rotary Encoder Demo";
//init timer2
void Timer2_Init(void)
{
	TCNT2=0x00;
} 
//start timer2
void Timer2_Start(void)
{
	TCCR2|=(1<<CS22)|(1<<CS21); //prescaller 256 ~122 interrupts/s
	TIMSK|=(1<<TOIE2);//Enable Timer0 Overflow interrupts
}
//timer ISR check for rotarry encoder status
ISR(TIMER2_OVF_vect)
{
//reading rotary and button
RotaryCheckStatus();
}
void MainInit(void)
{
	// Wait a little while the display starts up
	for(volatile uint16_t i=0; i<15000; i++);
	// Initialize the LCD
	ks0108Init(0);
	ks0108SelectFont(SC, ks0108ReadFontData, BLACK);
	//startup
	ks0108ClearScreen();
	ks0108GotoXY(0,0);
	ks0108Puts_P(DEMO);
	//init rottary
	RotaryInit();;
	//taimerio 2 nustatymas
	Timer2_Init();
	//Taimerio 2 paleidimas
	Timer2_Start();
	//enable global interrupts
	sei();
}
void MainScreenUpdate(void)
{
		//update encoder status on screen
		if (RotaryGetStatus() ==3)
		{
			ks0108ClearScreen();
			ks0108DrawRoundRect(5, 20, 117, 20, 8, BLACK);
			ks0108GotoXY(20,25);
			ks0108Puts_P(BUTTON);
			RotaryResetStatus();	
		}
		if (RotaryGetStatus() == 1)
		{	
			ks0108ClearScreen();
			ks0108DrawRoundRect(5, 20, 117, 20, 8, BLACK);
			ks0108GotoXY(20,25);
			ks0108Puts_P(LEFT);
			RotaryResetStatus();
		}
		if (RotaryGetStatus() == 2)
		{	
			ks0108ClearScreen();
			ks0108DrawRoundRect(5, 20, 117, 20, 8, BLACK);
			ks0108GotoXY(20,25);
			ks0108Puts_P(RIGHT);
			RotaryResetStatus();
		}
}
int main(void) {
	//initialize peripherals
	MainInit();
	//start loop
	while(1)
	{
		//update LCD information on status change
		MainScreenUpdate();
	}
	
}


